var Config = /*#__PURE__*/function () {
  /**
   * @constructor
   * @param {Object} deps
   * @param {String} deps.appName
   */
  function Config() {
    this._config = {
      AVAILABLE_STATUS: {
        CANCELLED: 'CANCELLED',
        COMPLETED: 'COMPLETED 🥳 ',
        ERROR: 'ERROR 🤬',
        IN_PROGRESS: 'IN_PROGRESS',
        QUEUED: 'QUEUED'
      },
      AVAILABLE_PRIORITIES: {
        LOW: 0,
        MEDIUM: 25,
        HIGH: 50,
        HIGHEST: 100
      },
      DEFAULT_CULTURE: 'es-ES',
      DEFAULT_CURRENCY: 'EUR'
    };
  }

  /**
   * @method
   * @param {String} key
   * @return {*}
   */
  var _proto = Config.prototype;
  _proto.get = function get(key) {
    return this._config[key];
  }

  /**
   * @method
   * @param {String} key
   * @param {*} value
   * @return {*}
   */;
  _proto.set = function set(key, value) {
    if (value !== undefined) this._config[key] = value;
    return this;
  };
  return Config;
}();
export { Config as default };