import { TaskServicesFactory } from '../Services/factory.js';
import { CancelWorkTaskUseCase } from './CancelWorkTaskUseCase.js';
import { ErrorWorkTaskUseCase } from './ErrorWorkTaskUseCase.js';
import { FinishWorkTaskUseCase } from './FinishWorkTaskUseCase.js';
import { MarkErrorTaskUseCase } from './MarkErrorTaskUseCase.js';
import { ProcessInProgressTaskUseCase } from './ProcessInProgressTaskUseCase.js';
import { ProcessQueuedTaskUseCase } from './ProcessQueuedTaskUseCase.js';
import { RunSimpleTaskUseCase } from './RunSimpleTaskUseCase.js';
import { RunTaskUseCase } from './RunTaskUseCase.js';
import { SetWorkPercentageTaskUseCase } from './SetWorkPercentageTaskUseCase.js';
var TaskUseCasesFactory = function TaskUseCasesFactory() {};
TaskUseCasesFactory.runTaskUseCase = function (_ref) {
  var config = _ref.config;
  var runTaskUseCase = new RunTaskUseCase({
    config: config,
    runTaskServiceFactory: TaskServicesFactory.runTaskService
  });
  return runTaskUseCase;
};
TaskUseCasesFactory.runSimpleTaskUseCase = function (_ref2) {
  var config = _ref2.config;
  var runSimpleTaskUseCase = new RunSimpleTaskUseCase({
    config: config,
    runSimpleTaskServiceFactory: TaskServicesFactory.runSimpleTaskService
  });
  return runSimpleTaskUseCase;
};
TaskUseCasesFactory.setWorkPercentageTaskUseCase = function (_ref3) {
  var config = _ref3.config;
  return new SetWorkPercentageTaskUseCase({
    config: config,
    setWorkPercentageTaskServiceFactory: TaskServicesFactory.setWorkPercentageTaskService
  });
};
TaskUseCasesFactory.finishWorkTaskUseCase = function (_ref4) {
  var config = _ref4.config;
  return new FinishWorkTaskUseCase({
    config: config,
    finishWorkTaskServiceFactory: TaskServicesFactory.finishWorkTaskService
  });
};
TaskUseCasesFactory.cancelWorkTaskUseCase = function (_ref5) {
  var config = _ref5.config;
  return new CancelWorkTaskUseCase({
    config: config,
    cancelWorkTaskServiceFactory: TaskServicesFactory.cancelWorkTaskService
  });
};
TaskUseCasesFactory.errorWorkTaskUseCase = function (_ref6) {
  var config = _ref6.config;
  return new ErrorWorkTaskUseCase({
    config: config,
    errorWorkTaskServiceFactory: TaskServicesFactory.errorWorkTaskService
  });
};
TaskUseCasesFactory.processQueuedTaskUseCase = function (_ref7) {
  var config = _ref7.config;
  return new ProcessQueuedTaskUseCase({
    config: config,
    processQueuedTaskServiceFactory: TaskServicesFactory.processQueuedTaskService
  });
};
TaskUseCasesFactory.processInProgressTaskUseCase = function (_ref8) {
  var config = _ref8.config;
  return new ProcessInProgressTaskUseCase({
    config: config,
    processInProgressTaskServiceFactory: TaskServicesFactory.processInProgressTaskService
  });
};
TaskUseCasesFactory.markErrorTaskUseCase = function (_ref9) {
  var config = _ref9.config;
  return new MarkErrorTaskUseCase({
    config: config,
    markErrorTaskServiceFactory: TaskServicesFactory.markErrorTaskService
  });
};
export { TaskUseCasesFactory as default };