import { useRef } from 'react';
import PropTypes from 'prop-types';
import AtomProgressBar from '@s-ui/react-atom-progress-bar';
import MoleculeAccordion, { moleculeAccordionBehavior, MoleculeAccordionItem } from '@s-ui/react-molecule-accordion';
import MoleculeBadgeCounter, { moleculeBadgeCounterSizes } from '@s-ui/react-molecule-badge-counter';
import MoleculeDrawer, { MoleculeDrawerOverlay, moleculeDrawerPlacements, moleculeDrawerSizes } from '@s-ui/react-molecule-drawer';
import { TaskManagerProvider } from './components/TaskManagerContext.js';
import useContext from './hooks/useContext.js';
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
export default function ToolTaskManager(_ref) {
  var _ref$isVisible = _ref.isVisible,
    isVisible = _ref$isVisible === void 0 ? true : _ref$isVisible;
  window.taskManager = useContext();
  var _window$taskManager = window.taskManager,
    getState = _window$taskManager.getState,
    toggleTab = _window$taskManager.toggleTab;
  var state = getState();
  var drawerRef = useRef();
  var _onClick = function _onClick() {
    toggleTab();
  };
  var getDrawer = function getDrawer() {
    return /*#__PURE__*/_jsxs(_Fragment, {
      children: [/*#__PURE__*/_jsx(MoleculeDrawerOverlay, {
        isVisible: state.toggleTab
      }), /*#__PURE__*/_jsx(MoleculeDrawer, {
        closeOnOutsideClick: true,
        isOpen: state.toggleTab,
        onClose: _onClick,
        placement: moleculeDrawerPlacements.BOTTOM,
        ref: drawerRef,
        size: moleculeDrawerSizes.AUTO,
        children: /*#__PURE__*/_jsx("div", {
          className: "sui-ToolTaskManager-container",
          children: /*#__PURE__*/_jsx(MoleculeAccordion, {
            as: "div",
            behavior: moleculeAccordionBehavior.MULTIPLE,
            children: /*#__PURE__*/_jsx(_Fragment, {
              children: getItems()
            })
          })
        })
      })]
    });
  };
  var getItems = function getItems() {
    return /*#__PURE__*/_jsx(_Fragment, {
      children: state.tasks.map(function (task) {
        return /*#__PURE__*/_jsx(MoleculeAccordionItem, {
          value: task.id,
          label: task.status + " - " + task.name,
          content: /*#__PURE__*/_jsx(_Fragment, {
            children: task.work.map(function (work) {
              return /*#__PURE__*/_jsxs("div", {
                className: "sui-ToolTaskManager-work",
                children: [/*#__PURE__*/_jsxs("div", {
                  className: "sui-ToolTaskManager-workInfo",
                  children: [work.status, " - ", work.name, " - ", work.percentage, "%", work.percentage === 100 && '✅']
                }), work.percentage !== 100 ? /*#__PURE__*/_jsx("div", {
                  className: "sui-ToolTaskManager-workProgressBar",
                  children: /*#__PURE__*/_jsx(AtomProgressBar, {
                    hideIndicator: true,
                    percentage: work.percentage,
                    type: "line",
                    size: "small"
                  })
                }) : null]
              });
            })
          })
        }, task.id);
      })
    });
  };
  if (!isVisible) return null;
  return /*#__PURE__*/_jsxs("div", {
    className: "sui-ToolTaskManager",
    children: [/*#__PURE__*/_jsx(MoleculeBadgeCounter, {
      label: state.tasks.length,
      size: moleculeBadgeCounterSizes.LARGE,
      children: /*#__PURE__*/_jsx("div", {
        className: "sui-ToolTaskManager-tab",
        onClick: _onClick,
        children: "\uD83E\uDD29 TaskManager \uD83E\uDD29"
      })
    }), getDrawer()]
  });
}
ToolTaskManager.displayName = 'ToolTaskManager';
export { TaskManagerProvider, useContext as useTaskManagerContext };